3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009,
8 # 2010, 2011, 2012, 2013, 2014, 2015, 2017 Free Software Foundation
9 # Originally by Gerald Pfeifer <gerald@pfeifer.com>, August 1998.
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License. A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
21 # If the first parameter reads --patch, the second parameter is considered
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
42 # Default options used when updating (none).
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
51 ######## Anything below shouldn't be changed by regular users.
53 # Arrange for the value of $0 to be available for functions
56 # This function prints its arguments to standard output unless
60 if [ -z "$silent" ]; then
65 # This function prints a list of all generated files, along with their
66 # dependencies. Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies
() {
69 sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
71 fixincludes
/configure
: fixincludes
/configure.ac fixincludes
/aclocal.
m4
72 fixincludes
/config.h.
in: fixincludes
/configure.ac fixincludes
/aclocal.
m4
74 intl
/plural.c
: intl
/plural.y
75 intl
/plural-config.h
: intl
/plural.y
76 intl
/configure
: intl
/configure.ac intl
/aclocal.
m4
77 intl
/config.h.
in: intl
/configure.ac intl
/aclocal.
m4
78 # Now, proceed to gcc automatically generated files
79 gcc
/configure
: gcc
/configure.ac
80 gcc
/cstamp-h.
in: gcc
/configure.ac
81 gcc
/config.
in: gcc
/cstamp-h.
in
82 gcc
/fixinc
/fixincl.x
: gcc
/fixinc
/fixincl.tpl gcc
/fixinc
/inclhack.def
83 gcc
/config
/aarch64
/aarch64-tune.md
: gcc
/config
/aarch64
/aarch64-cores.def gcc
/config
/aarch64
/gentune.sh
84 gcc
/config
/arm
/arm-tune.md
: gcc
/config
/arm
/arm-cpus.
in gcc
/config
/arm
/parsecpu.
awk
85 gcc
/config
/arm
/arm-tables.opt
: gcc
/config
/arm
/arm-cpus.
in gcc
/config
/arm
/parsecpu.
awk
86 gcc
/config
/c6x
/c6x-tables.opt
: gcc
/config
/c6x
/c6x-isas.def gcc
/config
/c6x
/genopt.sh
87 gcc
/config
/c6x
/c6x-sched.md
: gcc
/config
/c6x
/c6x-sched.md.
in gcc
/config
/c6x
/gensched.sh
88 gcc
/config
/c6x
/c6x-mult.md
: gcc
/config
/c6x
/c6x-mult.md.
in gcc
/config
/c6x
/genmult.sh
89 gcc
/config
/loongarch
/loongarch-str.h
: gcc
/config
/loongarch
/genopts
/genstr.sh gcc
/config
/loongarch
/genopts
/loongarch-strings
90 gcc
/config
/loongarch
/loongarch.opt
: gcc
/config
/loongarch
/genopts
/genstr.sh gcc
/config
/loongarch
/genopts
/loongarch.opt.
in
91 gcc
/config
/m68k
/m68k-tables.opt
: gcc
/config
/m68k
/m68k-devices.def gcc
/config
/m68k
/m68k-isas.def gcc
/config
/m68k
/m68k-microarchs.def gcc
/config
/m68k
/genopt.sh
92 gcc
/config
/mips
/mips-tables.opt
: gcc
/config
/mips
/mips-cpus.def gcc
/config
/mips
/genopt.sh
93 gcc
/config
/rs6000
/rs6000-tables.opt
: gcc
/config
/rs6000
/rs6000-cpus.def gcc
/config
/rs6000
/genopt.sh
94 gcc
/config
/rs6000
/fusion.md
: gcc
/config
/rs6000
/genfusion.pl
95 # And then, language-specific files
96 gcc
/cp
/cfns.h
: gcc
/cp
/cfns.gperf
97 gcc
/cp
/std-name-hint.h
: gcc
/cp
/std-name-hint.gperf
98 gcc
/cp
/std-name-hint.gperf
: gcc
/cp
/cxxapi-data.csv
99 gcc
/m
2/configure
: gcc
/m
2/configure.ac
100 gcc
/m
2/gm2config.h.
in: gcc
/m
2/configure.ac
101 gcc
/m
2/gm2-libs
/config-host
: gcc
/m
2/gm2-libs
/config-host.
in
103 # Without this, _Pragma3.c can have a false negative.
104 gcc
/testsuite
/gcc.dg
/cpp
/_Pragma3.c
: gcc
/testsuite
/gcc.dg
/cpp
/mi1c.h
105 # Similarly, without this, you will see:
106 # direct2s.c:35: warning: current file is older than direct2.c
107 gcc
/testsuite
/gcc.dg
/cpp
/direct2s.c
: gcc
/testsuite
/gcc.dg
/cpp
/direct2.c
109 lto-plugin
/configure
: lto-plugin
/configure.ac lto-plugin
/aclocal.
m4
110 lto-plugin
/Makefile.
in: lto-plugin
/Makefile.am lto-plugin
/aclocal.
m4
112 c
++tools
/configure
: c
++tools
/configure.ac
113 c
++tools
/config.h.
in: c
++tools
/configure.ac
114 # And libraries, at last
115 libbanshee
/configure
: libbanshee
/configure.ac
116 libmudflap
/configure
: libmudflap
/configure.ac
117 libobjc
/configure
: libobjc
/configure.ac
118 zlib
/aclocal.
m4: zlib
/configure.ac zlib
/acinclude.
m4
119 zlib
/Makefile.
in: zlib
/Makefile.am zlib
/configure.ac zlib
/aclocal.
m4
120 zlib
/configure
: zlib
/configure.ac zlib
/aclocal.
m4
121 fastjar
/aclocal.
m4: fastjar
/configure.ac
122 fastjar
/Makefile.
in: fastjar
/Makefile.am fastjar
/configure.ac fastjar
/aclocal.
m4
123 fastjar
/configure
: fastjar
/configure.ac fastjar
/aclocal.
m4
124 boehm-gc
/aclocal.
m4: boehm-gc
/configure.ac
125 boehm-gc
/Makefile.
in: boehm-gc
/Makefile.am boehm-gc
/configure.ac boehm-gc
/aclocal.
m4
126 boehm-gc
/configure
: boehm-gc
/configure.ac boehm-gc
/aclocal.
m4
127 libada
/configure
: libada
/configure.ac
128 libffi
/aclocal.
m4: libffi
/configure.ac libffi
/acinclude.
m4
129 libffi
/Makefile.
in: libffi
/Makefile.am libffi
/configure.ac libffi
/aclocal.
m4
130 libffi
/configure
: libffi
/configure.ac libffi
/aclocal.
m4
131 libffi
/fficonfig.h.
in: libffi
/configure.ac libffi
/aclocal.
m4
132 libgfortran
/aclocal.
m4: libgfortran
/configure.ac libgfortran
/acinclude.
m4
133 libgfortran
/Makefile.
in: libgfortran
/Makefile.am libgfortran
/configure.ac libgfortran
/aclocal.
m4
134 libgm
2/Makefile.
in: libgm
2/Makefile.am libgm
2/configure.ac libgm
2/aclocal.
m4
135 libgm
2/aclocal.
m4: libgm
2/configure.ac
136 libgm
2/libm2cor
/Makefile.
in: libgm
2/libm2cor
/Makefile.am
137 libgm
2/libm2pim
/Makefile.
in: libgm
2/libm2pim
/Makefile.am
138 libgm
2/libm2iso
/Makefile.
in: libgm
2/libm2iso
/Makefile.am
139 libgm
2/libm2log
/Makefile.
in: libgm
2/libm2log
/Makefile.am
140 libgm
2/libm2min
/Makefile.
in: libgm
2/libm2min
/Makefile.am
141 libquadmath
/configure
: libquadmath
/configure.ac libquadmath
/aclocal.
m4
142 libquadmath
/aclocal.
m4: libquadmath
/configure.ac libquadmath
/acinclude.
m4
143 libquadmath
/Makefile.
in: libquadmath
/Makefile.am libquadmath
/configure.ac libgfortran
/aclocal.
m4
144 libgfortran
/configure
: libgfortran
/configure.ac libgfortran
/aclocal.
m4
145 libcody
/configure
: libcody
/configure.ac libcody
/config.
m4
146 libcpp
/aclocal.
m4: libcpp
/configure.ac
147 libcpp
/Makefile.
in: libcpp
/configure.ac libcpp
/aclocal.
m4
148 libcpp
/configure
: libcpp
/configure.ac libcpp
/aclocal.
m4
149 libgomp
/aclocal.
m4: libgomp
/configure.ac libgomp
/acinclude.
m4
150 libgomp
/Makefile.am
: libgomp
/plugin
/Makefrag.am
151 libgomp
/Makefile.
in: libgomp
/Makefile.am libgomp
/aclocal.
m4
152 libgomp
/testsuite
/Makefile.
in: libgomp
/testsuite
/Makefile.am libgomp
/aclocal.
m4
153 libgomp
/configure.ac
: libgomp
/plugin
/configfrag.ac
154 libgomp
/configure
: libgomp
/configure.ac libgomp
/aclocal.
m4
155 libgomp
/config.h.
in: libgomp
/configure.ac libgomp
/aclocal.
m4
156 libgrust
/Makefile.
in: libgrust
/Makefile.am libgrust
/aclocal.
m4
157 libgrust
/aclocal.
m4: libgrust
/configure.ac
158 libgrust
/configure
: libgrust
/configure.ac libgrust
/aclocal.
m4
159 libgrust
/libproc_macro_internal
/Makefile.
in: libgrust
/libproc_macro_internal
/Makefile.am libgrust
/aclocal.
m4
160 libitm
/aclocal.
m4: libitm
/configure.ac libitm
/acinclude.
m4
161 libitm
/Makefile.
in: libitm
/Makefile.am libitm
/aclocal.
m4
162 libitm
/testsuite
/Makefile.
in: libitm
/testsuite
/Makefile.am libitm
/aclocal.
m4
163 libitm
/configure
: libitm
/configure.ac libitm
/aclocal.
m4
164 libitm
/config.h.
in: libitm
/configure.ac libitm
/aclocal.
m4
165 libatomic
/aclocal.
m4: libatomic
/configure.ac libatomic
/acinclude.
m4
166 libatomic
/Makefile.
in: libatomic
/Makefile.am libatomic
/aclocal.
m4
167 libatomic
/testsuite
/Makefile.
in: libatomic
/testsuite
/Makefile.am libatomic
/aclocal.
m4
168 libatomic
/configure
: libatomic
/configure.ac libatomic
/aclocal.
m4
169 libatomic
/auto-config.h.
in: libatomic
/configure.ac libatomic
/aclocal.
m4
170 libsanitizer
/aclocal.
m4: libsanitizer
/configure.ac libsanitizer
/acinclude.
m4
171 libsanitizer
/Makefile.
in: libsanitizer
/Makefile.am libsanitizer
/aclocal.
m4
172 libsanitizer
/configure
: libsanitizer
/configure.ac libsanitizer
/aclocal.
m4
173 libsanitizer
/asan
/Makefile.
in: libsanitizer
/asan
/Makefile.am libsanitizer
/aclocal.
m4
174 libsanitizer
/interception
/Makefile.
in: libsanitizer
/interception
/Makefile.am libsanitizer
/aclocal.
m4
175 libsanitizer
/sanitizer_common
/Makefile.
in: libsanitizer
/sanitizer_common
/Makefile.am libsanitizer
/aclocal.
m4
176 libvtv
/aclocal.
m4: libvtv
/configure.ac libvtv
/acinclude.
m4
177 libvtv
/Makefile.
in: libvtv
/Makefile.am libvtv
/aclocal.
m4
178 libvtv
/configure
: libvtv
/configure.ac libvtv
/aclocal.
m4
179 libbacktrace
/aclocal.
m4: libbacktrace
/configure.ac
180 libbacktrace
/Makefile.
in: libbacktrace
/Makefile.am libbacktrace
/aclocal.
m4
181 libbacktrace
/configure
: libbacktrace
/configure.ac libbacktrace
/aclocal.
m4
182 libbacktrace
/config.h.
in: libbacktrace
/configure.ac libbacktrace
/aclocal.
m4
183 libphobos
/Makefile.
in: libphobos
/Makefile.am libphobos
/configure.ac libphobos
/aclocal.
m4
184 libphobos
/aclocal.
m4: libphobos
/configure.ac libphobos
/acinclude.
m4
185 libphobos
/config.h.
in: libphobos
/configure.ac libphobos
/aclocal.
m4
186 libphobos
/configure
: libphobos
/configure.ac libphobos
/aclocal.
m4
187 libphobos
/src
/Makefile.
in: libphobos
/src
/Makefile.am libphobos
/aclocal.
m4
188 libphobos
/testsuite
/Makefile.
in: libphobos
/testsuite
/Makefile.am libphobos
/aclocal.
m4
189 libstdc
++-v3/include
/bits
/version.h
: libstdc
++-v3/include
/bits
/version.def libstdc
++-v3/include
/bits
/version.tpl
191 Makefile.
in: Makefile.tpl Makefile.def
192 configure
: configure.ac config
/acx.
m4
197 # This function touches generated files such that the ``end'' user does
198 # not have to rebuild them.
201 echo 'all: \' > Makefile.$$
202 files_and_dependencies | sed 's
, .
*, \\,' >> Makefile.$$
203 echo '; @true
' >> Makefile.$$
204 files_and_dependencies | sed 's
, ,: ,' >> Makefile.$$
205 files_and_dependencies | sed 's
, .
*, \\,' >> Makefile.$$
206 echo ':' >> Makefile.$$
207 echo ' @
for f
in $? $@
; do test -f $
$f ||
exit 0; done; \' >> Makefile.$$
208 echo ' echo Touching $@...; \' >> Makefile.$$
209 chat ' echo Touching $@...
1>&2; \' >> Makefile.$$
210 echo ' touch $@' >> Makefile.$$
211 files_and_dependencies |
sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
213 # We would have to explicitly shut off the "Entering... Leaving..."
214 # messages through "--no-print-directory" to handle the case when
215 # we were called from a recursive invocation (i.e. "$(MAKE)" in a
216 # Makefile, not just make). Passing only "-s" doesn't help then,
217 # because make has helpfully added "-w" to MAKEFLAGS automatically.
218 # Unfortunately we do not require GNU make other than for building
219 # and testing, so let's just grep known text explicitly echoed by
221 while ${MAKE-make} -s -f Makefile.$$ all |
grep Touching
> /dev
/null
; do
228 # Whenever we update the tree or install a patch, we may be modifying
229 # this script. By re-execing it, we ensure that the appropriate
230 # dependencies and rules will be used.
231 touch_files_reexec
() {
232 chat
"Adjusting file timestamps"
233 exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
236 # This functions applies a patch to an existing tree.
239 echo "Applying patch file $1"
242 gzip -d -c "$1" |
patch -p1 ;;
244 bzip2 -d -c "$1" |
patch -p1 ;;
252 # Check whether this indeed looks like a local tree.
253 if [ ! -f gcc
/reload.cc
]; then
254 echo "This does not seem to be a GCC tree!"
266 # First of all, check whether we are going to process a patch.
268 if test "$#" != 2; then
269 echo "$1" expects only one argument
>&2
277 if test "$#" != 1; then
278 echo "$1" does not expect any argument
>&2
286 if test "$#" != 1; then
287 echo "$1" does not expect any argument
>&2
290 files_and_dependencies |
sed 's/ /: /'
295 sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
300 -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
306 # Check for known version control systems.
307 if [ -d .git
] ||
[ -f .git
]; then
308 GCC_GIT
=${GCC_GIT-${GIT-git}}
310 elif [ -d .hg
]; then
311 GCC_HG
=${GCC_HG-${HG-hg}}
313 elif [ -d .svn
]; then
314 GCC_SVN
=${GCC_SVN-${SVN-svn}}
317 echo "This does not seem to be a GCC GIT/HG/SVN tree!"
321 # Check command-line options
322 if [ x
"${1}"x
= x
"--nostdflags"x
]; then
325 set -- $UPDATE_OPTIONS ${1+"$@"}
330 chat
"Updating GIT tree"
332 $GCC_GIT diff --quiet --exit-code HEAD
333 if [ $?
-ne 0 ]; then
334 echo "Attempting to update a dirty git tree!" >&2
335 echo "Commit or stash your changes first and retry." >&2
339 $GCC_GIT pull
${silent+-q} --rebase ${1+"$@"}
340 if [ $?
-ne 0 ]; then
342 echo "git pull of full tree failed." >&2
346 # Open-coded version of "git gcc-descr" from contrib/gcc-git-customization.sh
347 revision
=`$GCC_GIT log -n1 --pretty=tformat:%h`
348 r
=`$GCC_GIT describe --all --match 'basepoints/gcc-[0-9]*' HEAD \
349 | sed -n 's,^\(tags/\)\?basepoints/gcc-\([0-9]\+\)-\([0-9]\+\)-g[0-9a-f]*$,r\2-\3,p;s,^\(tags/\)\?basepoints/gcc-\([0-9]\+\)$,r\2-0,p'`;
350 if test -n "$r"; then
351 o
=`$GCC_GIT config --get gcc-config.upstream`;
352 rr
=`echo $r | sed -n 's,^r\([0-9]\+\)-[0-9]\+\(-g[0-9a-f]\+\)\?$,\1,p'`;
353 if $GCC_GIT rev-parse
--verify --quiet ${o:-origin}/releases
/gcc-
$rr >/dev
/null
; then
358 if $GCC_GIT merge-base
--is-ancestor HEAD
${o:-origin}/$m; then
359 revision
=${r}-g${revision};
362 branch
=`$GCC_GIT name-rev --name-only HEAD || :`
366 chat
"Updating HG tree"
368 # Add -q so untracked files aren't listed.
369 if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
370 echo "Attempting to update a dirty hg tree!" >&2
371 echo "Commit or revert your changes first and retry." >&2
375 # Check for mq extension. mq patches must be popped so tip has
376 # been converted from the SVN tree.
377 if [ -d .hg
/patches
] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
378 # FIXME: Perhaps pop queue instead? We could do that since we
379 # know the tree is clean.
380 echo "Attempting to update hg tree with mq patches applied!" >&2
381 echo "Pop your patches first and retry." >&2
385 # Update tree, but make sure to only pull the default branch.
386 # Otherwise all branches in the upstream repo are added, even if
387 # only a single one has been cloned.
388 $GCC_HG pull
${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
389 if [ $?
-ne 0 ]; then
391 echo "hg pull of full tree failed." >&2
395 # Update tree. Needs to be done separately from pull so
396 # gcc_update -rREV works.
397 $GCC_HG update
${silent+-q} ${1+"$@"}
398 if [ $?
-ne 0 ]; then
400 echo "hg update of full tree failed." >&2
404 # Extract SVN revision corresponding to parents, as stored by
405 # hg convert. Before hg 1.4.3, there's no template keyword
406 # corresponding to the extra: tag, so need to use hg log --debug
407 # to extract the info.
408 parents
=`$GCC_HG parents --template '{rev}'`
409 convert_revision
=`$GCC_HG log --debug -r$parents | \
410 sed -ne "/^extra:.*convert_revision=svn:/ {
414 revision
=`echo $convert_revision | sed -e 's/.*@//'`
415 branch
=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
419 chat
"Updating SVN tree"
421 $GCC_SVN ${silent+-q} --non-interactive update
${1+"$@"}
422 if [ $?
-ne 0 ]; then
424 echo "SVN update of full tree failed." >&2
428 revision
=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
429 branch
=`$GCC_SVN info | sed -ne "/^URL:/ {
438 rm -f LAST_UPDATED gcc
/REVISION
441 echo "`TZ=UTC date` (revision $revision)"
443 echo "[$branch $revision]" > gcc
/REVISION